/* dense.c */
/* Fortran interface file */

/*
* This file was generated automatically by bfort from the C source
* file.  
 */

#ifdef PETSC_USE_POINTER_CONVERSION
#if defined(__cplusplus)
extern "C" { 
#endif 
extern void *PetscToPointer(void*);
extern int PetscFromPointer(void *);
extern void PetscRmPointer(void*);
#if defined(__cplusplus)
} 
#endif 

#else

#define PetscToPointer(a) (*(long *)(a))
#define PetscFromPointer(a) (long)(a)
#define PetscRmPointer(a)
#endif

#include "petscfix.h"
#include "slepceps.h"
#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssorteigenvalues_ PEPSSORTEIGENVALUES
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssorteigenvalues_ pepssorteigenvalues
#else
#define epssorteigenvalues_ pepssorteigenvalues_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssorteigenvalues_ EPSSORTEIGENVALUES
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssorteigenvalues_ epssorteigenvalues
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsdensenhep_ PEPSDENSENHEP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsdensenhep_ pepsdensenhep
#else
#define epsdensenhep_ pepsdensenhep_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsdensenhep_ EPSDENSENHEP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsdensenhep_ epsdensenhep
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsdensenhepsorted_ PEPSDENSENHEPSORTED
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsdensenhepsorted_ pepsdensenhepsorted
#else
#define epsdensenhepsorted_ pepsdensenhepsorted_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsdensenhepsorted_ EPSDENSENHEPSORTED
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsdensenhepsorted_ epsdensenhepsorted
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsdenseschur_ PEPSDENSESCHUR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsdenseschur_ pepsdenseschur
#else
#define epsdenseschur_ pepsdenseschur_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsdenseschur_ EPSDENSESCHUR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsdenseschur_ epsdenseschur
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssortdenseschur_ PEPSSORTDENSESCHUR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssortdenseschur_ pepssortdenseschur
#else
#define epssortdenseschur_ pepssortdenseschur_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssortdenseschur_ EPSSORTDENSESCHUR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssortdenseschur_ epssortdenseschur
#endif
#endif



/* Definitions of Fortran Wrapper routines */
#if defined(__cplusplus)
extern "C" {
#endif
void PETSC_STDCALL  epssorteigenvalues_(int *n,PetscScalar *eig,PetscScalar *eigi,EPSWhich *which,int *nev,int *permout, int *ierr ){
*ierr = EPSSortEigenvalues(*n,
	(PetscScalar* )PetscToPointer( (eig) ),
	(PetscScalar* )PetscToPointer( (eigi) ),*which,*nev,permout);
}
void PETSC_STDCALL  epsdensenhep_(int *n,PetscScalar *A,PetscScalar *w,PetscScalar *wi,PetscScalar *V, int *ierr ){
*ierr = EPSDenseNHEP(*n,
	(PetscScalar* )PetscToPointer( (A) ),
	(PetscScalar* )PetscToPointer( (w) ),
	(PetscScalar* )PetscToPointer( (wi) ),
	(PetscScalar* )PetscToPointer( (V) ));
}
void PETSC_STDCALL  epsdensenhepsorted_(int *n,PetscScalar *A,PetscScalar *w,PetscScalar *wi,PetscScalar *V,int *m,EPSWhich *which, int *ierr ){
*ierr = EPSDenseNHEPSorted(*n,
	(PetscScalar* )PetscToPointer( (A) ),
	(PetscScalar* )PetscToPointer( (w) ),
	(PetscScalar* )PetscToPointer( (wi) ),
	(PetscScalar* )PetscToPointer( (V) ),*m,*which);
}
void PETSC_STDCALL  epsdenseschur_(int *n,int *k,PetscScalar *H,PetscScalar *Z,PetscScalar *wr,PetscScalar *wi, int *ierr ){
*ierr = EPSDenseSchur(*n,*k,
	(PetscScalar* )PetscToPointer( (H) ),
	(PetscScalar* )PetscToPointer( (Z) ),
	(PetscScalar* )PetscToPointer( (wr) ),
	(PetscScalar* )PetscToPointer( (wi) ));
}
void PETSC_STDCALL  epssortdenseschur_(int *n,int *k,PetscScalar *T,PetscScalar *Z,PetscScalar *wr,PetscScalar *wi, int *ierr ){
*ierr = EPSSortDenseSchur(*n,*k,
	(PetscScalar* )PetscToPointer( (T) ),
	(PetscScalar* )PetscToPointer( (Z) ),
	(PetscScalar* )PetscToPointer( (wr) ),
	(PetscScalar* )PetscToPointer( (wi) ));
}
#if defined(__cplusplus)
}
#endif
