/* setup.c */
/* Fortran interface file */

/*
* This file was generated automatically by bfort from the C source
* file.  
 */

#ifdef PETSC_USE_POINTER_CONVERSION
#if defined(__cplusplus)
extern "C" { 
#endif 
extern void *PetscToPointer(void*);
extern int PetscFromPointer(void *);
extern void PetscRmPointer(void*);
#if defined(__cplusplus)
} 
#endif 

#else

#define PetscToPointer(a) (*(long *)(a))
#define PetscFromPointer(a) (long)(a)
#define PetscRmPointer(a)
#endif

#include "petscfix.h"
#include "slepceps.h"
#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssetup_ PEPSSETUP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssetup_ pepssetup
#else
#define epssetup_ pepssetup_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssetup_ EPSSETUP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssetup_ epssetup
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssetinitialvector_ PEPSSETINITIALVECTOR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssetinitialvector_ pepssetinitialvector
#else
#define epssetinitialvector_ pepssetinitialvector_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssetinitialvector_ EPSSETINITIALVECTOR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssetinitialvector_ epssetinitialvector
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsgetinitialvector_ PEPSGETINITIALVECTOR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsgetinitialvector_ pepsgetinitialvector
#else
#define epsgetinitialvector_ pepsgetinitialvector_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsgetinitialvector_ EPSGETINITIALVECTOR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsgetinitialvector_ epsgetinitialvector
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssetoperators_ PEPSSETOPERATORS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssetoperators_ pepssetoperators
#else
#define epssetoperators_ pepssetoperators_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epssetoperators_ EPSSETOPERATORS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epssetoperators_ epssetoperators
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsattachdeflationspace_ PEPSATTACHDEFLATIONSPACE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsattachdeflationspace_ pepsattachdeflationspace
#else
#define epsattachdeflationspace_ pepsattachdeflationspace_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsattachdeflationspace_ EPSATTACHDEFLATIONSPACE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsattachdeflationspace_ epsattachdeflationspace
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsremovedeflationspace_ PEPSREMOVEDEFLATIONSPACE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsremovedeflationspace_ pepsremovedeflationspace
#else
#define epsremovedeflationspace_ pepsremovedeflationspace_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define epsremovedeflationspace_ EPSREMOVEDEFLATIONSPACE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define epsremovedeflationspace_ epsremovedeflationspace
#endif
#endif



/* Definitions of Fortran Wrapper routines */
#if defined(__cplusplus)
extern "C" {
#endif
void PETSC_STDCALL  epssetup_(EPS *eps, int *ierr ){
*ierr = EPSSetUp(*eps);
}
void PETSC_STDCALL  epssetinitialvector_(EPS *eps,Vec vec, int *ierr ){
*ierr = EPSSetInitialVector(*eps,
	(Vec)PetscToPointer( (vec) ));
}
void PETSC_STDCALL  epsgetinitialvector_(EPS *eps,Vec *vec, int *ierr ){
*ierr = EPSGetInitialVector(*eps,vec);
}
void PETSC_STDCALL  epssetoperators_(EPS *eps,Mat A,Mat B, int *ierr ){
*ierr = EPSSetOperators(*eps,
	(Mat)PetscToPointer( (A) ),
	(Mat)PetscToPointer( (B) ));
}
void PETSC_STDCALL  epsattachdeflationspace_(EPS *eps,int *n,Vec *ds,PetscTruth *ortho, int *ierr ){
*ierr = EPSAttachDeflationSpace(*eps,*n,ds,*ortho);
}
void PETSC_STDCALL  epsremovedeflationspace_(EPS *eps, int *ierr ){
*ierr = EPSRemoveDeflationSpace(*eps);
}
#if defined(__cplusplus)
}
#endif
